  
  
  library ieee;
  use ieee.std_logic_1164.all;
  use ieee.numeric_std.all;

  entity counter is
    port (
      clk:         in  std_logic;
      arst_n:      in  std_logic;
      enable:      in  std_logic;
      direction:   in  std_logic;
      parallel_in: in  std_logic_vector (3 downto 0);
      load:        in  std_logic;
      counter:     out std_logic_vector (3 downto 0);
      sigout:      out std_logic
    );
  end entity counter;

  architecture rtl of counter is
  begin

    process (clk, arst_n)
    begin
      if arst_n = '0' then counter <= (others => '0');
      elsif rising_edge(clk) then
        if enable = '1' then
          if load = '1' then counter <= parallel_in;
          else 
            if direction = '1' then
               counter <= std_logic_vector(unsigned(counter) + 1);
            else counter <= std_logic_vector(unsigned(counter) - 1);
            end if;
          end if;
        end if;
      end if;
    end process;

  end architecture rtl;


